image: "rust:latest"

stages:
  - Cargo:Test
  - Cargo:Build
  - Cargo:Doc
  - build
  - test
  - deploy

cache:
  paths:
    #- ./target/debug

variables:
  CRATE_NAME: ""

before_script:
  - rustc --version
  - cargo --version

check:
  stage: Cargo:Test
  when: manual
  script:
    - cargo check --verbose

run:
  stage: Cargo:Build
  when: manual
  script:
    - cargo run --verbose

binary:
  variables:
    CARGO_BINARY: "comments"
  stage: Cargo:Build
  when: manual
  script:
    - cargo build --verbose --bin $CARGO_BINARY
    - ./target/debug/$CARGO_BINARY

workspace:
  variables:
    CARGO_WORKSPACE: "guessing_game"
  stage: Cargo:Build
  when: manual
  script:
    - cd $CARGO_WORKSPACE
    - cargo build --verbose --workspace
    - cd ../
    - ./target/debug/$CARGO_WORKSPACE

all_binaries:
  stage: Cargo:Build
  when: manual
  script:
    - cargo build --verbose --bins
  artifacts:
    name: "$CI_JOB_NAME"
    expire_in: 1 day
    paths:
      - ./target/debug

release:
  stage: Cargo:Build
  when: manual
  script:
    - cargo build --verbose --release --bins
  artifacts:
    name: "$CI_JOB_NAME"
    expire_in: 1 day
    paths:
      - ./target/release
          
test:
  when: manual
  stage: Cargo:Test
  script:
    - cargo test --all --verbose
  only:
    changes:
    - "**/*.{rs}"

doc_all:
  when: manual
  stage: Cargo:Doc
  script:
  - cargo doc --verbose --target-dir public
  - cp favicon.ico public/doc/favicon.ico
  - cp crown.svg public/doc/crown.svg
  - cp crown.svg public/doc/guessing_game/crown.svg
  - cp favicon.ico public/doc/guessing_game/favicon.ico
  - cp crown.svg public/doc/display/crown.svg
  - cp favicon.ico public/doc/display/favicon.ico  
  - cp crown.svg public/doc/comments/crown.svg
  - cp favicon.ico public/doc/comments/favicon.ico
  artifacts:
    paths:
    - public

doc_workspace:
  variables:
    CARGO_WORKSPACE: "guessing_game"
  when: manual
  stage: Cargo:Doc
  script:
  - cd $CARGO_WORKSPACE
  - cargo doc --verbose --workspace --target-dir public
  - cd ../
  artifacts:
    paths:
    - public

pages:
  stage: Cargo:Doc
  script:
  # Create documentation for all rust source files
  - cargo doc --all --verbose --target-dir public
  # Create documentation for rust examples files
  # Each example must be generated seperately
  - rustdoc ./examples/debut.rs --output ./public/examples
  - rustdoc ./examples/comments.rs --output ./public/examples
  - rustdoc ./examples/hello_world/main.rs --output ./public/examples
  - cp ./public/doc/favicon.ico.bak ./public/doc/favicon.ico
  - cp ./public/doc/favicon.ico.bak ./public/examples/favicon.ico
  artifacts:
    paths:
    - public
  only:
    variables:
      - $CI_COMMIT_MESSAGE =~ /cargo doc/

#################################################################
#################################################################
# Document Rust Examples
#################################################################
#################################################################


